/*
**************************
*    BfaCore Reforged    *
**************************
*/

-- Disable duplicate and deprecated quests
DELETE FROM `disables` WHERE `sourceType`=1 AND `entry` IN (2158,31141);
INSERT INTO `disables` (`sourceType`, `entry`, `flags`, `params_0`, `params_1`, `comment`) VALUES
(1,2158,0,"","","Duplicate, deprecated quest - Rest and relaxation"),
(1,31141,0,"","","Deprecated quest - Calligraphed letter (Northshire Abbey)");

-- Quest progression text
DELETE FROM `quest_request_items` WHERE `ID` IN (26390, 26391, 26152, 54101, 31693,26320,26230,26271,26229,26288,26228,26209,26322,26290,26348,26297,26287,26237,26708,26562,26636,26637,26587,26514,54103,26714,26506,26519,26573,26638,26560,26561,26511,26513,26508,26505,26646,26570,26520,26692,26713,54104,26503,26569,26693,26694,26607,26544,54106,26512,26640,26504,26510,26571,26545);
INSERT INTO `quest_request_items` (`ID`, `EmoteOnComplete`, `EmoteOnIncomplete`, `EmoteOnCompleteDelay`, `EmoteOnIncompleteDelay`, `CompletionText`, `VerifiedBuild`) VALUES
-- Elwynn Forest Quests
(26390, 0, 0, 0, 0, "Have you found Kurtok?", 35662),
(26391, 0, 0, 0, 0, "Have you put out the fires?", 35662),
(26152, 0, 0, 0, 0, "Turning in a bounty?", 35662),
(31693, 0, 0, 0, 0, "There's nobody I can't beat!", 35662),
(54101, 0, 0, 0, 0, "Let us keep investigating.", 35662),
-- Westfall Quests
(26320, 0, 0, 0, 0, "What have you found out, $n?", 35662),
(26230, 0, 0, 0, 0, "Pies don't make themselves - usually.", 35662),
(26271, 0, 0, 0, 0, "Have you fed the homeless?", 35662),
(26229, 0, 0, 0, 0, "I just want those kobolds dead. Dead!", 35662),
(26288, 0, 0, 0, 0, "Have you found Jango?", 35662),
(26228, 0, 0, 0, 0, "Be careful with my old house. I plan to hand that off to my kids when they move out.", 35662),
(26209, 0, 0, 0, 0, "Anything yet?", 35662),
(26322, 0, 0, 0, 0, "What news do you bring from Westfall?", 35662),
(26290, 0, 0, 0, 0, "I won't let you down, $n.", 35662),
(26348, 0, 0, 0, 0, "Kill 7 Tidehunters, and 7 Oracles and I will see to it that you are rewarded.", 35662),
(26297, 0, 0, 0, 0, "What happened?", 35662),
(26287, 0, 0, 0, 0, "Defend Sentinel Hill!", 35662),
(26237, 0, 0, 0, 0, "Did you destroy the harvest watchers?", 35662),
-- Redridge Mountains Quests
(26708, 0, 0, 0, 0, "We're ready for the final assault.", 35662),
(26562, 0, 0, 0, 0, "Well look at that! The team's all here... everyone but Keeshan.", 35662),
(26636, 0, 0, 0, 0, "Leaves and poop - that's what I need. ", 35662),
(26637, 0, 0, 0, 0, "Did you recover the glands? ", 35662),
(26587, 0, 0, 0, 0, "Did you get the cage key? ", 35662),
(26514, 0, 0, 0, 0, "Did you recover those collars? ", 35662),
(54103, 0, 0, 0, 0, "Let's find out everything we can. ", 35662),
(26714, 0, 0, 0, 0, "...", 35662),
(26506, 0, 0, 0, 0, "Have you gotten my ingredients? ", 35662),
(26519, 0, 0, 0, 0, "<The orb emanates powerful magic> ", 35662),
(26573, 0, 0, 0, 0, "Did you locate the headband and amulet?", 35662),
(26638, 0, 0, 0, 0, "NO MERCY!", 35662),
(26560, 0, 0, 0, 0, "Messner! Damn, it's good to see a friendly face. Get me out of here!", 35662),
(26561, 0, 0, 0, 0, "<Krakauer groans>. ", 35662),
(26511, 0, 0, 0, 0, "Have you killed all the murlocs?", 35662),
(26513, 0, 0, 0, 0, "Did you recover the supplies?", 35662),
(26508, 0, 0, 0, 0, "Hi. I miss my necklace. My daddy got it for me. Daddy says that there are monsters in the lake. Did you beat up any monsters?", 35662),
(26505, 0, 0, 0, 0, "Where did I put my monocle?! Conacher is that you? ", 35662),
(26646, 0, 0, 0, 0, "$n?", 35662),
(26570, 0, 0, 0, 0, "How goes the orc slaughter? ", 35662),
(26520, 0, 0, 0, 0, "That boulder fell from the sky. It's a miracle he's still alive.", 35662),
(26692, 0, 0, 0, 0, "Are they all dead?", 35662),
(26713, 0, 0, 0, 0, "This doesn't look good.", 35662),
(54104, 0, 0, 0, 0, "Well? What are you waiting for? ", 35662),
(26503, 0, 0, 0, 0, "Did you find the gnoll plans? ", 35662),
(26569, 0, 0, 0, 0, "Did you recover the spyglasses?", 35662),
(26693, 0, 0, 0, 0, "I hear you loud and clear, $n.", 35662),
(26694, 0, 0, 0, 0, "I hear you loud and clear, $n.", 35662),
(26607, 0, 0, 0, 0, "You again?", 35662),
(26544, 0, 0, 0, 0, "What have you found out?", 35662),
(54106, 0, 0, 0, 0, "Let's find out everything we can. ", 35662),
(26512, 0, 0, 0, 0, "What are you waiting around here for?", 35662),
(26640, 0, 0, 0, 0, "They got Brubaker?", 35662),
(26504, 0, 0, 0, 0, "Come to collect on a bounty?", 35662),
(26510, 0, 0, 0, 0, "Have you recovered the gnomecorder?", 35662),
(26571, 0, 0, 0, 0, "Did you terminate Murdunk and Homurk?", 35662),
(26545, 0, 0, 0, 0, "Do you have the Blackrock invasion plans?", 35662);

-- Quest completion text
DELETE FROM `quest_offer_reward` WHERE `ID` IN (26150, 31308, 37112, 54100, 54102, 31693, 31316, 54101, 26396, 26152,26230, 26370, 26322, 26761,26708,26562,26636,26637,26587,26514,54103,26714,26668,54105,26506,54107,26519,26573,26638,26586,26616,26567,26560,26561,26511,26513,26508,26505,26639,26646,26570,26563,26520,26692,26713,54104,26503,26569,26693,26694,26607,26544,26568,26651,54106,26512,26640,26504,26510,26571,26545);
INSERT INTO `quest_offer_reward` (`ID`, `Emote1`, `Emote2`, `Emote3`, `Emote4`, `EmoteDelay1`, `EmoteDelay2`, `EmoteDelay3`, `EmoteDelay4`, `RewardText`, `VerifiedBuild`) VALUES
-- Elwynn Forest Quests
(26150, 0, 0, 0, 0, 0, 0, 0, 0, "William sent you? Bless his soul. I... I'm ok... It's just... Well...", 0),
(37112, 0, 0, 0, 0, 0, 0, 0, 0, "Rest and relaxation for the tired and cold -- that's our motto!$B$BPlease, take a seat by the fire and rest your weary bones.", 0),
(31308, 0, 0, 0, 0, 0, 0, 0, 0, "Nice work, $n! You're better with those pets than I thought!", 0),
(54100, 0, 0, 0, 0, 0, 0, 0, 0, "There is no time to waste. Let us begin our investigation.", 0),
(54102, 0, 0, 0, 0, 0, 0, 0, 0, "There are few paths through Redridge, save this one.$B$BWe should start the next stage of our investigation here.", 0),
(31693, 0, 0, 0, 0, 0, 0, 0, 0, "Ouch, you really are a good pet trainer! I guess you're the exception.", 0),
(31316, 0, 0, 0, 0, 0, 0, 0, 0, "You're better with those pets than I thought!", 0),
(54101, 0, 0, 0, 0, 0, 0, 0, 0, "SI:7 lurking around Stormwind? Hmm, probably after the same thing we are.$B$BWe need to keep moving.", 0),
(26396, 0, 0, 0, 0, 0, 0, 0, 0, "Great, you brought the armor! We'll get this divvied to those who need it immediately. Thank you, $n. Your efforts have been a great help to us. And now that you're no stranger to gryphons, I hope you'll come and lend your aid to Goldshire often!", 0),
(26152, 0, 0, 0, 0, 0, 0, 0, 0, "And justice is served!", 0),
-- Westfall Quests
(26230, 0, 0, 0, 0, 0, 0, 0, 0, "Just smellin' you comin' got my stomach rumblin'! We're gonna eat like kings tonight!", 0),
(26370, 0, 0, 0, 0, 0, 0, 0, 0, "Five years of work burned to the ground in five minutes. Damn the Defias!$B$BAnd this is only the beginning, $n! We have a long, hard road ahead of us.", 0),
(26322, 0, 0, 0, 0, 0, 0, 0, 0, "I will deploy a battalion of soldiers to Westfall at once! With the Defias Brotherhood reborn, an old threat to the kingdom is renewed.", 0),
-- Redridge Mountains Quests
(26761, 0, 0, 0, 0, 0, 0, 0, 0, "I heard about the Defias making a return. Terrible news. I wish I had better news, but it would appear that Lakeshire is under attack! We are losing citizens left and right. Our own guard are spread far too thin to handle the situation. We need a hero to step up!", 0),
(26708, 0, 0, 0, 0, 0, 0, 0, 0, "The only thing left to deal with now are the orcs holding out at Stonewatch Keep.", 0),
(26562, 0, 0, 0, 0, 0, 0, 0, 0, "About damn time you sissies showed up. My arms were gettin' tired.", 0),
(26636, 0, 0, 0, 0, 0, 0, 0, 0, "Nice job, rookie. I'm gonna go ahead and put the camo in the box. We should be ready soon. ", 0),
(26637, 0, 0, 0, 0, 0, 0, 0, 0, "Perfect. Those orcs won't know what hit 'em - literally. I'll need a few minutes to get these in working order and then I'll put them in the Bravo Company field kit.", 0),
(26587, 0, 0, 0, 0, 0, 0, 0, 0, "IT'S PAYBACK TIME!", 0),
(26514, 0, 0, 0, 0, 0, 0, 0, 0, "<The gnomecorder crackles and pops.>$B$BGood WORK, $n. I've just been handed some important information. It would appear that our most hated enemy, the Blackrock orcs, have wised up...$B$B<The gnomecorder whirs as a compartment opens up.>$B$BI've transferred a few silver over to you for the gnome, erm, gnoll kills.$B$B('These gnolls have wised up!')", 0),
(54103, 0, 0, 0, 0, 0, 0, 0, 0, "So, Shaw was involved? SI:7... again.$B$BPerhaps a coincidence, perhaps NOT.$B$BWe have little to go off of. Let us assume Saurfang continued his path eastward, off of the main trails. ", 0),
(26714, 0, 0, 0, 0, 0, 0, 0, 0, "<A single tear rolls down Troteman's left cheek.>$B$BThey died in defense of the Alliance. In defense of our kingdom! Heroes, all of them, and they will be laid to rest as such.", 0),
(26668, 0, 0, 0, 0, 0, 0, 0, 0, "Did you see those orcs explode? THAT'S HOW WE DO IT IN BRAVO COMPANY! Now to clean up the rest of these jackasses.", 0),
(54105, 0, 0, 0, 0, 0, 0, 0, 0, "This is one of the few pathways through the Redridge Mountains. If Saurfang came this direction, it was through this pass.", 0),
(26506, 0, 0, 0, 0, 0, 0, 0, 0, "PERFECT! I'll put these in the pot right away. Dinner should be ready in a few hours.$B$BThank you, darling!", 0),
(54107, 0, 0, 0, 0, 0, 0, 0, 0, "It be too late! Dey beat us here!", 0),
(26519, 0, 0, 0, 0, 0, 0, 0, 0, "<The orb hisses as you touch it.>", 0),
(26573, 0, 0, 0, 0, 0, 0, 0, 0, "I hope with these items and with his crew all rescued he'll have a change of heart. We can't do this without Keeshan.", 0),
(26638, 0, 0, 0, 0, 0, 0, 0, 0, "Great work, $n. We need to move quickly before they send for reinforcements.", 0),
(26586, 0, 0, 0, 0, 0, 0, 0, 0, "Keeshan? You mean JOHNNY'S ALIVE? You bet your sweet behind I'll help, but first you gotta get me out of this damned cage.", 0),
(26616, 0, 0, 0, 0, 0, 0, 0, 0, "It's orc killin' time.", 0),
(26567, 0, 0, 0, 0, 0, 0, 0, 0, "Help you? Help these people? These people that would rather spit on me than crack a smile? ", 0),
(26560, 0, 0, 0, 0, 0, 0, 0, 0, "I know where they're holding Krakauer and Danforth. We gotta hurry. They were prepping those two for a sacrifice! ", 0),
(26561, 0, 0, 0, 0, 0, 0, 0, 0, "Wha... Where am I? What happened? Messner? Jorgensen?$B$BOH MY GOSH! We have to get to Danforth! It might already be too late! ", 0),
(26511, 0, 0, 0, 0, 0, 0, 0, 0, "That ought to teach those murlocs a lesson. Hopefully the next time they decide to raid our town they'll think twice.$B$BWe both know that won't happen. ", 0),
(26513, 0, 0, 0, 0, 0, 0, 0, 0, "Thank you, citizen. Without you, we would have starved or worse, been forced to go out and get food ourselves.", 0),
(26508, 0, 0, 0, 0, 0, 0, 0, 0, "Thank you for finding my necklace mister $c... you are very kind! My kitty thanks you too - isn't that right Effsee? ", 0),
(26505, 0, 0, 0, 0, 0, 0, 0, 0, "<Magistrate Solomon puts on his monocle.>$B$BOh, you're not Conacher. What have you got there?$B$B<Magistrate Solomon takes Parker's report from you.>$B$BOh for pity's sake. Yowler? AGAIN? ", 0),
(26639, 0, 0, 0, 0, 0, 0, 0, 0, "Brubaker is dead. It looks like the orcs are attempting to send a message with this grizzly display. Upon closer examination you notice something in Brubaker's pouch.", 0),
(26646, 0, 0, 0, 0, 0, 0, 0, 0, "<The radio on the Bravo Company field kit crackles.>$B$BLooks like the P.O.W.s are free. Time to initiate Operation: End ALL.$B$B('War is in my blood.')", 0),
(26570, 0, 0, 0, 0, 0, 0, 0, 0, "You've probably bought us another day, maybe two. Nice work, $n.", 0),
(26563, 0, 0, 0, 0, 0, 0, 0, 0, "<Colonel Troteman salutes.>$B$BUnbelievable work, $n. You've managed to rescue the entire Bravo Company from the clutches of the Blackrock orcs? With Keeshan's team rescued and Keeshan's belongings returned, there's no way Keeshan could refuse us.", 0),
(26520, 0, 0, 0, 0, 0, 0, 0, 0, "You used an ettin to remove the boulder that was crushing Foreman Oslow? Incredible work, $n! Oslow will be grateful once he regains his composure. ", 0),
(26692, 0, 0, 0, 0, 0, 0, 0, 0, "<Danforth's voice comes in over the Bravo Company field kit.>$B$BHello? Is this thing on$B$B<You hear Keeshan's voice in the background, and some muffled scrapes as they adjust the signal.>$B$BThere we go. Good work, $n. We're closing in on the Blackrock high command. There's nowhere left for those dogs to run.$B$B('Danforth: Slay them all.') ", 0),
(26713, 0, 0, 0, 0, 0, 0, 0, 0, "<The Bravo Company field kit beeps loudly.>$B$BCome in, $n. Are you there? If you can hear me: Blackrock has the upper hand. I repeat. Blackrock has the upper hand. GET BRAVO COMPANY OUT OF TH...$B$B<Troteman cuts out.>('It's a trap! Get out!')", 0),
(54104, 0, 0, 0, 0, 0, 0, 0, 0, "Well, that was invigorating.$B$BBased on the size of that spider and how injured it was, I'd venture a guess that we are on the right track.$B$BAnd I think I know where to head next. ", 0),
(26503, 0, 0, 0, 0, 0, 0, 0, 0, "I knew it! Looks like Yowler is behind this uprising - which is incredible, because we keep killing gnolls named Yowler. I don't know how many sons the original Yowler had, but it's got to be close to a hundred.$B$BWell, looks like we got ourselves another Yowler to kill.$B$BMagistrate Solomon must be notified.", 0),
(26569, 0, 0, 0, 0, 0, 0, 0, 0, "Fantastic work, $n! These will come in handy for our next project, the Lakeshire SUPER BRIDGE, meant to traverse the length of Lake Everstill. It should be done in 20 or so years. Give or take a decade or two. ", 0),
(26693, 0, 0, 0, 0, 0, 0, 0, 0, "<Keeshan comes in over the Bravo Company field kit.>$B$BNow the easy part is over, it's time for phase two.$B$B('Fangore was a chump.') ", 0),
(26694, 0, 0, 0, 0, 0, 0, 0, 0, "He teleported away? Mentioned Darkblaze? What the hell is going on here.$B$BLooks like it's time to strap in and finish this nonsense.", 0),
(26607, 0, 0, 0, 0, 0, 0, 0, 0, "<Keeshan takes the bundle from you and opens it.>$B$BMy bow... and knife! Where did you...$B$BJade's amulet... My darling Jade.$B$B<Keeshan picks up his red headband.>$B$BWe got orcs to kill. ", 0),
(26544, 0, 0, 0, 0, 0, 0, 0, 0, "<The gnomecorder buzzes and whirs.>$B$BJust put the missive in the little compartment and I'll read it. I am fluent in orcish.$B$B<You hear a distraught yell in the background.>$B$BIt looks like these orcs are here under the direct command of Yowler. That means Yowler must have the orc invasion plan.$B$B('Solomon: Fluent in orcish.') ", 0),
(26568, 0, 0, 0, 0, 0, 0, 0, 0, "<Troteman sighs.>$B$BI'm not giving up on him, $n, and I'm not giving up on Redridge. We need to boost his spirits... Rouse the slumbering monster within him! ", 0),
(26651, 0, 0, 0, 0, 0, 0, 0, 0, "And now, we blow the whole damned thing up.", 0),
(54106, 0, 0, 0, 0, 0, 0, 0, 0, "Thank you for your assistance in this investigation, champion. We have all but confirmed Saurfang's current location.$B$BI must report back to the warchief before we make any further moves. We will summon you if we require your assistance again. ", 0),
(26512, 0, 0, 0, 0, 0, 0, 0, 0, "<The gnomecorder crackles and pops.>Can you hear me, $n? Is this thing on? Ah, yes, I see you there now.$B$BLet's get to work!$B$B('Reception coming in loud and clear!') ", 0),
(26640, 0, 0, 0, 0, 0, 0, 0, 0, "<Keeshan reads the report.>$B$BDAMN IT! This just got complicated. We've got prisoners of war to rescue before we can blow up the valley.$B$BNot to mention the orcs have black dragons on their side.$B$BAre you ready, $n?", 0),
(26504, 0, 0, 0, 0, 0, 0, 0, 0, "A job well done deserves a reward, wouldn't you say?$B$BDon't spend this all in one place, $c. Better to spread it around, if you catch my drift.", 0),
(26510, 0, 0, 0, 0, 0, 0, 0, 0, "Excellent! Let me make a few adjustments here and we should be good to go.", 0),
(26571, 0, 0, 0, 0, 0, 0, 0, 0, "<The gnomecorder buzzes with energy.>$B$BCome in, $n. Do you copy? Troteman here. Great job on getting Keeshan's weapons back! Now there's one final mission you have to run. Are you up to the challenge?$B$B'You send that many, don't forget one thing. A good supply of body bags.') ", 0),
(26545, 0, 0, 0, 0, 0, 0, 0, 0, "<Magistrate Solomon takes the plans from you and begins reading.>$B$BShadowhide army!? Damn those orcs to hell! These invasion plans speak of a massive build up of orcish and gnoll forces in the east. Looks like Gath'Ilzogg, the Blackrock general, is preparing to march his armies across Lakeshire and attack Stormwind directly! ", 0);