/*
 * Copyright (C) 2021 BfaCore Reforged
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ETERNAL_PALACE
#define ETERNAL_PALACE

#define DataHeader "ETERNAL_PALACE"

uint32 const EncounterCount = 9;

enum EncounterData
{
	DATA_NO_BOSS = 0,
	DATA_COMMANDER_SIVARA,
	DATA_BLACKWATER_BEHEMOTH,
	DATA_RADIANCE_OF_AZSHARA,
	DATA_LADY_ASHVANE,
	DATA_ORGOZOA,
	DATA_THE_QUEENS_COURT,
	DATA_ZAQUL,
	DATA_QUEEN_AZSHARA,
};

enum Creatures
{
	NPC_COMMANDER_SIVARA = 151881,
	NPC_HANDLER_FROST_BOLT = 500512,
	NPC_HANDLER_TOXIC_BOLT = 500513,
	NPC_QUEEN_AZSHARA_INTRO = 154480,
	NPC_SZALIRA = 154807,
	NPC_VIZJARA = 155859,
	NPC_SAKJA = 155859,
	NPC_ZSALISS = 155900,
	NPC_RADIANCE_OF_AZSHARA = 152364,
	NPC_RUNE_STALKER = 152511,
	NPC_ARCANE_BOMB = 152873,
	NPC_STORMLING_EP = 152816,
	NPC_BLACKWATER_BEHEMOTH = 150653,
	NPC_SHIMMERSKIN_PUFFERFISH = 150773,
    NPC_LADY_ASHVANE = 152236,
    NPC_CORAL_GROWTH = 152726,
    NPC_BRINY_BUBBLE = 153194, 
	NPC_SILIVAZ = 152853,
	NPC_PASHMAR = 152852,
	NPC_LIGHTNING_ORB = 153521,	
	BOSS_LADY_ASHVANE = 152236,
	BOSS_BLACKWATER_BEHEMOTH = 150653,
	NPC_OXYGEN_RICH_MEMBRANE = 150585,
	NPC_DARKWATER_JELLYFISH = 153779,
	NPC_PUFFERFISH = 155278,
	BOSS_RADIANCE_OF_AZSHARA = 152364,
	NPC_STORMLING = 152816,
	NPC_STORMWRAITH = 152512,
	NPC_ARCANE_BOMB_TRIGGER = 155901,
	BOSS_ORGOZOA = 152128,
	NPC_ZOATROID = 156625,
	NPC_ZANJIR_MYRMIDON = 156131,
	NPC_AZSHARI_WITCH = 156132,
	NPC_DREADCOIL_HULK = 156133,
	NPC_HATCHERY_EGG = 154361,
	BOSS_SILIVAZ_THE_ZEALOUS = 152853,
	BOSS_PASHMAR_THE_FANATICAL = 152852,
	NPC_POTENT_SPARK = 153335,
	NPC_QUEEN_AZSHARA_DECREE = 154480,
	NPC_FORM_RANKS = 153370,
	NPC_STAND_ALONE = 153367,
	NPC_DEFERRED_SENTENCE = 153369,
	NPC_OBEY_OR_SUFFER = 153368,
	NPC_REPEAT_PERFORMANCE = 153371,
	BOSS_ZAQUL = 150859,
	NPC_ZAQUL_FEAR_REALM = 154889,
	NPC_ZAQUL_DELIRIUM_REALM = 154890,
	NPC_FEAR_GATE = 152192,
	NPC_HORRIFIC_SUMMONER = 154175,
	NPC_HORRIFIC_SUMMONER_DARK_PASSAGE = 154174,
	NPC_HORRIFIC_VISION = 151581,
	NPC_UNLEASHED_NIGHTMARE = 154612,
	NPC_TENTACLE_DELIRIUM = 152574,
	NPC_PORTAL_TO_AZSHARA = 156646,
	NPC_QUEEN_AZSHARA_RP = 153653,
	NPC_FACING_TRIGGER_CRUSHING_GRASP = 155683,
	NPC_CRUSHING_GRASP_TRIGGER = 151034,
	NPC_DELIRIUM_REALM_TRIGGER = 155912,
	NPC_MADDENING_ERUPTION_TRIGGER = 151586, // FEAR STALKER used for maddening eruption script, DNT
	NPC_ECHO_OF_DELIRIUM = 154685,
	NPC_ECHO_OF_FEAR = 154682,
	NPC_REALITY_PORTAL = 151592,
	NPC_FIRST_ARCANIST_THALYSSRA = 152604,
	NPC_QUEEN_AZSHARA = 152910,
	NPC_FIRST_ARCANIST_THALYSSRA_2 = 155158,
	NPC_JAINA_PROUDMOORE = 155156,
	NPC_SHANDRIS_FEATHERMOON = 155161,
	NPC_LORTHEMAR_THERON = 155162,
	NPC_TITAN_CONSOLE = 154959,
	NPC_WARD = 153175,
	NPC_AETHANEL = 153059,
	NPC_CYRANUS = 153060,
	NPC_OVERZEALOUS_HULK = 155643,
	NPC_CRUSHING_DEPTHS = 155845,
	NPC_AZSHARAS_INDOMITABLE = 155354,
	NPC_AZSHARAS_DEVOTED = 154240,
	NPC_LADY_VENOMTONGE = 153090,
	NPC_SERENA_SCARSCALE = 153091,
	NPC_VENNA_SEASTORM = 153092,
	NPC_LOYAL_MYRMIDON = 154565,
};

enum Gameobjects
{
	GO_SIVARA_ENCOUNTER = 334101,
	GO_SIVARA_LEFT = 334103,
	GO_SIVARA_RIGHT = 334102,
	GO_LADY_ASHVANE_ENCOUNTER = 332139,
    GO_CIRCULAR_WALL_ASHVANE = 329650,    
    GO_ORGOZOA_ENCOUNTER_BEH = 332144,
    GO_ORGOZOA_ENCOUNTER_FINAL = 330208,
    GO_QUEENS_COURT_LEFT = 332136,
    GO_QUEENS_COURT_RIGHT = 332137,
    GO_QUEENS_COURT_FINAL = 329699,
    GO_PALACE_DOOR = 328388,
	GO_AZSHARA_CHEST = 327682,
};

#endif // ETERNAL_PALACE
