/*
 * Copyright 2021 BfaCore
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef ULDIR_H
#define ULDIR_H

uint32 const EncounterCount = 8;

enum EncounterData
{
    DATA_TALOC = 1,
    DATA_MOTHER,
    DATA_DEVOURER,
    DATA_ZEKVOZ,
    DATA_VECTIS,
    DATA_ZUL,
    DATA_MYTHRAX,
    DATA_GHUUN,
    DATA_GHUUN_FINAL
};

enum CreatureIds
{
    NPC_TALOC = 137119,
    NPC_MOTHER = 135452,
    NPC_DEVOURER = 133298,
    NPC_ZEKVOZ = 134445,
    NPC_VECTIS = 134442,
    NPC_ZUL = 138967,
    NPC_MYTHRAX = 134546,
    NPC_GHUUN = 132998,
    NPC_RAMNANT_OF_CORRUPTION = 136315,
    NPC_VOLATILE_DROPLET = 138530,
    NPC_COALESCED_BLOOD = 138959,
    NPC_PURIFYING_FLAME = 136289,
    NPC_PURIFYING_FLAME_2 = 136325,
    NPC_WIND_TUNNEL = 136322,
    NPC_CHAMBER_NUMBER_1 = 136429,
    NPC_CHAMBER_NUMBER_2 = 137022,
    NPC_CHAMBER_NUMBER_3 = 137023,
    NPC_DEFENSE_GRID = 136298,
    NPC_CORRUPTION_CORPUSCLE = 133492,
    NPC_EYE_BEAM = 134785,
    NPC_TITAN_SPARK = 134883,
    NPC_YOGG_SARON = 135127,
    NPC_PROJECTION_OF_YOGG_SARON = 135129,
    NPC_PROJECTION_OF_CTHUN = 134726,
    NPC_PLAGUE_AMALGAM = 135016,
    NPC_PATHOGEN_BOMB = 135687,
    NPC_ENGORGED_PARASITE = 140478,
    NPC_OMINOUS_CLOUD_STALKER = 135079,
    NPC_SILITHID_WARRIOR = 134503,
    NPC_NERUBIAN_VOIDWEAVER = 135824,
    NPC_SURGING_DARKNESS_BUNNY = 135183,
    NPC_HOGGER_COSTUME = 134079, //?
    NPC_ORB_OF_CORRUPTION = 159150,
    NPC_ORB_OF_CORRUPTION_VISUAL_SOAK = 137043,
    NPC_WARPED_PROJECTION = 135888,
    NPC_GUARDIAN_OF_YOGG_SARON = 135089,
    NPC_BLOOD_RITUAL = 134012,
    NPC_POOL_OF_DARKNESS = 139171,
    NPC_CRAWG = 139059,
    NPC_NAZMANI_BLOODHEXER = 139057,
    NPC_NAZMANI_CRUSHER = 139051,
    NPC_NAZMANI_BLOODWEAVER = 142801,
    NPC_NAZMANI_VEINSPLITTER = 142800,
    NPC_NAZMANI_DOMINATOR = 142802,
    NPC_MINION_OF_ZUL_ULDIR = 138493,
    NPC_ANIMATED_ICHOR = 139195,
    NPC_VISION_OF_MADNESS = 139487,
    NPC_NRAQI_DESTROYER = 139381,
    NPC_XALZAIX = 138324,
    NPC_OBLIVION_SPHERE = 138492,
    NPC_GHUUN_STATIC = 132998,
    NPC_GHUUN_NON_STATIC = 163405,
    NPC_POWER_MATRIX = 134107,
    NPC_DARK_YOUNG = 138529,
    NPC_CYCLOPEAN_TERROR = 138531,
    NPC_REORIGINATION_DRIVE = 136263,
    NPC_BLIGHTSPREADER_TENDRIL = 134590,
    NPC_GIBBERING_HORROR = 134010,
    NPC_SPAWN_OF_GHUUN = 136461,
    NPC_MATRIX_SURGE = 139910,
    NPC_BURSTING_BOIL = 141695,
};

enum Gameobjects
{
    GO_TALOC_ELEVATOR = 287464,
    GO_MOTHER_CACHE = 291079,
    GO_DOOR_ZUL_ENCOUNTER = 299086,
    GO_DOOR_ZUL_ENCOUNTER_SECOND = 299085,
    GO_DOOR_ZUL_ENCOUNTER_THIRD = 299084,
    GO_TITAN_CONSOLE_ZUL = 292788,
    GO_TRAPDOOR_ZUL = 287416,
    GO_MYTHRAX_DOOR = 291104,
    GO_HOLOGRAM_PROJECTOR_GHUUN = 289517,
    GO_ULDIR_TELEPORTER = 289557
};

enum Scenes
{
    SCENE_STAIRS = 2357
};

#endif // ULDIR_H
